'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Util = require('./Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Translator = (function () {
    function Translator() {
        _classCallCheck(this, Translator);

        this.langs = [];
        this.cache = {};
        this.provider = null;
    }

    _createClass(Translator, [{
        key: 'setup',
        value: function setup(alias, key, uri) {
            this.provider = Translator.createProvider(alias, key, uri);

            return this;
        }
    }, {
        key: 'getLangs',
        value: function getLangs() {
            if (this.langs.length) {
                return Promise.resolve(this.langs);
            }

            return this.provider.getLangs();
        }
    }, {
        key: 'translate',
        value: function translate(text, to, from) {
            var hash = _Util2.default.composeHash(text);
            var lang = _Util2.default.composeLangsAlias(from, to);

            if (typeof this.cache[lang] !== 'undefined' && typeof this.cache[lang][hash] !== 'undefined') {
                return Promise.resolve(this.cache[lang][hash]);
            }

            return this.provider.translate(text, to, from);
        }
    }, {
        key: 'lookup',
        value: function lookup(text, to, from) {
            var _this = this;

            var lang = _Util2.default.composeLangsAlias(from, to);

            return this.getLangs().then(function (langs) {
                _this.langs = langs;

                if (!_this.provider.supports(langs, to, from)) {
                    return null;
                }

                return _this.translate(text, to, from);
            }).then(function (trans) {
                if (typeof _this.cache[lang] === 'undefined') {
                    _this.cache[lang] = {};
                }
                _this.cache[lang][_Util2.default.composeHash(text)] = trans;

                return trans;
            });
        }
    }], [{
        key: 'addProvider',
        value: function addProvider(alias, Factory) {
            Translator.providerMap[alias] = Factory;
        }
    }, {
        key: 'createProvider',
        value: function createProvider(alias, key, uri) {
            if (typeof Translator.providerMap[alias] === 'undefined') {
                return null;
            }

            var Factory = Translator.providerMap[alias];

            return new Factory(key, uri);
        }
    }]);

    return Translator;
})();

Translator.providerMap = {};

exports.default = Translator;