'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fetch = require('./../fetch');

var _fetch2 = _interopRequireDefault(_fetch);

var _Util = require('./../Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GoogleProvider = (function () {
    function GoogleProvider(key, uri) {
        _classCallCheck(this, GoogleProvider);

        this.key = key;
        this.uri = uri;
    }

    _createClass(GoogleProvider, [{
        key: 'supports',
        value: function supports(langs, to, from) {
            return langs.indexOf(from) > -1 && langs.indexOf(to) > -1;
        }
    }, {
        key: 'getLangs',
        value: function getLangs() {
            return (0, _fetch2.default)(this.uri + 'languages' + _Util2.default.stringify({ key: this.key })).then(function (response) {
                return response.data.languages.map(function (item) {
                    return item.language;
                });
            });
        }
    }, {
        key: 'translate',
        value: function translate(text, to, from) {
            var data = {
                key: this.key,
                'q': text,
                source: from,
                target: to
            };

            return (0, _fetch2.default)(this.uri + _Util2.default.stringify(data)).then(function (response) {
                return response.data.translations.shift().translatedText;
            });
        }
    }]);

    return GoogleProvider;
})();

exports.default = GoogleProvider;