'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fetch = require('./../fetch');

var _fetch2 = _interopRequireDefault(_fetch);

var _Util = require('./../Util');

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var YandexProvider = (function () {
    function YandexProvider(key, uri) {
        _classCallCheck(this, YandexProvider);

        this.key = key;
        this.uri = uri;
    }

    _createClass(YandexProvider, [{
        key: 'supports',
        value: function supports(langs, to, from) {
            return langs.indexOf(_Util2.default.composeLangsAlias(from, to)) > -1;
        }
    }, {
        key: 'getLangs',
        value: function getLangs() {
            return (0, _fetch2.default)(this.uri + 'getLangs' + _Util2.default.stringify({ key: this.key })).then(function (response) {
                return response.dirs;
            });
        }
    }, {
        key: 'translate',
        value: function translate(text, to, from) {
            var data = {
                key: this.key,
                text: text,
                lang: _Util2.default.composeLangsAlias(from, to)
            };

            return (0, _fetch2.default)(this.uri + 'translate' + _Util2.default.stringify(data)).then(function (response) {
                return response.text.shift();
            });
        }
    }]);

    return YandexProvider;
})();

exports.default = YandexProvider;